C______________________________________________________________________________
C
C/ PROGRAM TO REFINE PARAMETERS  (THERMAL,SCALE,EXTINCTION AND ANHARMANICITY)/
C______________________________________________________________________________
C
       COMMON /ONE/ IHKL(1500),FOBS(1500),FC(1500),SF1(1500),SF2(1500),
     *SINT(1500),ERRCH(1500),FO(1500),AS(1500),AB(1500),SIGMA(150
     *0),W(1500),DELF(1500),ERRO(1500),A1(1500),SIG1(20),SIG(2000)
       COMMON A(16,16),IH(5,3),DISP1(4),DISP2(4),GIN(15,15),D(16),
     *FINAL(16,16),CRS(16,16),TITLE(20),B(16,16)
       OPEN(2,FILE='INcaf2')
       OPEN(4,FILE='OUTcaf2')
       OPEN(8,FILE='OFOFC')
       READ(2,*)NC
   10  FORMAT(I2)
       READ(2,30)TITLE
   30  FORMAT(20A4)
       WRITE(4,40)TITLE
       WRITE(5,40)TITLE
   40  FORMAT(//////,20X,20A4)
       READ(2,*)ICUBE,JPARA,NCYCL,IWILS,NOMIT,NSFC,THEM,AMU,GIM,RADIS,
     *DELTA
       WRITE(4,50)ICUBE,JPARA,NCYCL,IWILS,NOMIT,NSFC,THEM,AMU,GIM,
     *RADIS,DELTA
       WRITE(5,50)ICUBE,JPARA,NCYCL,IWILS,NOMIT,NSFC,THEM,AMU,GIM,
     *RADIS,DELTA
   50  FORMAT(6I3,2F8.4,F8.3,F8.4,F8.4)
       READ(2,*)ALMDA,CELL,SCALE,BAN,BCAT,CTDS,XFRAC,YFRAC,TEMP
       WRITE(4,60)ALMDA,CELL,SCALE,BAN,BCAT,CTDS,XFRAC,YFRAC,TEMP
       WRITE(5,60)ALMDA,CELL,SCALE,BAN,BCAT,CTDS,XFRAC,YFRAC,TEMP
   60  FORMAT(8F9.6,F8.1)
       DO 70 J=1,2
       IF(NSFC) 80,100,80
   80  READ(2,90) (A(J,I),B(J,I),I=1,21),DISP1(J),DISP2(J)
       WRITE(4,90) (A(J,I),B(J,I),I=1,21),DISP1(J),DISP2(J)
       WRITE(5,90) (A(J,I),B(J,I),I=1,21),DISP1(J),DISP2(J)
   90  FORMAT(8F10.4)
       GO TO 70
  100  READ(2,*) (A(J,I),I=1,4),(B(J,I),I=1,4),DISP1(J),DISP2(J)
       WRITE(4,110) (A(J,I),I=1,4),(B(J,I),I=1,4),DISP1(J),DISP2(J)
       WRITE(5,110) (A(J,I),I=1,4),(B(J,I),I=1,4),DISP1(J),DISP2(J)
  110  FORMAT(10F8.4)
   70  CONTINUE
       PHI=3.14159265
       N=0
  120  READ(2,130) ((IH(I,J),J=1,3),FO(I),SIG1(I),I=1,1)
       WRITE(4,130) ((IH(I,J),J=1,3),FO(I),SIG1(I),I=1,1)
       WRITE(5,130) ((IH(I,J),J=1,3),FO(I),SIG1(I),I=1,1)
  130  FORMAT(3I4,1X,F11.5,10X,F9.5)
       DO 140 I=1,1
       IF (IH(I,1)-99)150,160,160
  150  N=N+1
       IHKL(N)=(IH(I,1)+12)*1000+(IH(I,2)+12)*40+IH(I,3)+12
       FOBS(N)=FO(I)
       SIG(N)=SIG1(I)
140    CONTINUE
       GO TO 120
  160  IF (NOMIT) 240,240,170
  170  DO 180 I=1,NOMIT
       READ(2,190)J,K,L
  190  FORMAT(3I3)
       JK=(J+12)*1000+(K+12)*40+L+12
       DO 200 M=1,N
       IF (IHKL(M)-JK) 200,210,200
  200  CONTINUE
  210  MN=N-M
       DO 220 IC=1,MN
       IHKL(M)=IHKL(M+1)
       FOBS(M)=FOBS(M+1)
  220  M=M+1
       J=JK/1000-12
       K=(JK-(J+12)*1000)/40-12
       L=JK-(J+12)*1000-(K+12)*40-12
       WRITE(4,251)J,K,L
       WRITE(5,251)J,K,L
  251  FORMAT(20X,'OMITTED REFLECTION IS=',3I3)
  180  N=N-1
  240  RMINI=1.0
       SUMOB=0.0
        WRITE(4,252)TITLE
	WRITE(5,252)TITLE
 252   FORMAT(1X,'------------------------------------------------------
     *---------------------------',/,'OUTPUT DATA FOR',1X,20A4,/,'------
     *----------------------------')
       WRITE(4,250)N,NOMIT
       WRITE(5,250)N,NOMIT
  250  FORMAT (//,10X,'TOTAL NO OF REFLECTIONS=',I5,//,10X,'TOTAL OMITTE
     *D REFLECTIONS=',I3)
       DO 260 I=1,N
       JJ=IHKL(I)/1000-12
       K=(IHKL(I)-(JJ+12)*1000)/40-12
       L=IHKL(I)-(JJ+12)*1000 -(K+12)*40-12
       P=JJ**2+K**2+L**2
       SINT(I)=P/(4.*CELL**2)
       DO 270 J=1,JPARA
       IF (NSFC) 280,310,280
 280   DO 290 M=2,21
       DS=SQRT(SINT(I))
       IF(A(J,M)-DS) 290,300,300
 290   CONTINUE
 300   DEL=(B(J,M-1)-B(J,M))/(A(J,M)-A(J,M-1))
       SF=B(J,M)+DEL*(A(J,M)-DS)
       GO TO 330
 310   SF =0.0
       DO 320 M=1,4
       SRF=A(J,M)*EXP(-B(J,M)*SINT(I))
 320   SF=SF+SRF
 330   SF=SQRT((SF+DISP1(J))**2+DISP2(J)**2)
 270   FO(J)=SF
       SUMOB=SUMOB+FOBS(I)
       SF1(I)=FO(1)
       IF(2-JPARA) 340,340,260
  340  SF2(I)=FO(2)
       IF(3-JPARA) 350,360,260
  350  SF2(I)=FO(2)*YFRAC+FO(4)*(1.-YFRAC)
  360  SF1(I)=FO(1)*XFRAC+FO(3)*(1.-XFRAC)
  260  CONTINUE
       IF(2-JPARA) 449,447,448
  447  FDX=DISP2(2)
  448  FDY=DISP2(1)
  449  IF(3-JPARA) 470,460,450
  450  M=JPARA+2
       GO TO 471
  460  M=JPARA+2
       FDX=DISP2(2)
       GO TO 472
  470  M=JPARA+1
       FDX=DISP2(2)*YFRAC+DISP2(4)*(1.-YFRAC)
  472  FDY=DISP2(1)*XFRAC+DISP2(3)*(1.-XFRAC)
  471  DO 480 MN=1,NCYCL
       DO 490 I=1,M
       DO 490 J=1,M
       CRS(I,J)=0.0
       A(I,J)=0.0
  490  B(I,J)=0.0
       P=0.0
       Q=0.0
       DO 556 I=1,N
       SITE=SINT(I)*ALMDA**2
       THE=ATAN(SQRT(SITE/(1.-SITE)))*57.295779
       TDS=SIN(THE*2./57.295779)*SITE*CTDS
       CALL  EXTIN(RADIS,CELL,THEM,THE,ALMDA,GAMA)
       FCX=SF2(I)
       FCY=SF1(I)
       CALL SFC(ICUBE,JPARA,SCALE,GIM,BAN,BCAT,FC,IHKL,SINT,
     *I,FCX,FCY,FDX,FDY,AA,GAMA,TDS,Y,D)
       R=(FOBS(I)-ABS(FC(I)))
       S=ABS(R)
       P=P+S
       Q=Q+(S**2)
       DO 500 J=1,M
       DO 500 K=1,M
       A(J,K)=A(J,K)+D(J)*D(K)
 500   B(J,K)=B(J,K)+R*D(J)
 556   CONTINUE
       COM=Q/(N-M)
       R=P/SUMOB
       WRITE(4,510)R
  510  FORMAT(10X,'RMINIMUM=',F10.6)
       WRITE(4,520) MN
  520  FORMAT(//4X,'---------------',/,4X,'CYCLE NUMBER=',I2,/,4X,'-----
     *----------')
       IF (R-RMINI)530,540,540
  530  RMINI=R
       SM=SCALE
       BGIM=GIM
       BAM=BAN
       BCM=BCAT
       NM=MN-1
  540  CALL MATRX(A,B,M,FINAL)
       SCALE=SCALE+FINAL(1,1)
       SIGS=SQRT(A(1,1)*COM)
       GIM=GIM+FINAL(2,1)
       SIGG=SQRT(A(2,2)*COM)
       BAN=BAN+FINAL(3,1)
       SIGA=SQRT(A(3,3)*COM)
       BB1=ABS(BAN)	
C      WRITE(4,546)SCALE,SIGS,GIM,SIGG,BAN,SIGA
       WRITE(4,546)SCALE,SIGS,GIM,SIGG,BB1,SIGA
  546  FORMAT(5X,'SCALE FACTOR=',E12.5,'   +OR-   ',E12.5,/,5X,'EXTINCTI
     *ON  =',E12.5,'   +OR-   ',E12.5,/,5X,'B OF ANION  =',E12.5,'   +OR
     *-   ',E12.5)
       NN=1
       II=M-1
       DO 545 I=1,II
       JJ=I+1
       DO 545 J=JJ,M
       CRS(I,J)=A(I,J)/SQRT(A(I,I)*A(J,J))
  545  NN=NN+1
       IF (2-JPARA) 550,550,580
  550  BCAT=BCAT+FINAL(4,1)
       SIGC=SQRT(A(4,4)*COM)
       BB2=ABS(BCAT)
       WRITE (4,560) BCAT,SIGC
C       WRITE (4,560) BB2,SIGC
  560  FORMAT(5X,'B OF CATION =',E12.5,'   +OR-   ',E12.5)
  580  DO 570 I=1,II
       IJ=I+1
       DO 570 J=IJ,M
       IF(ABS(CRS(I,J))-0.5) 570,590,590
  590  WRITE(4,600)I,J,CRS(I,J)
  600  FORMAT(5X,'CORRELATION BETWEEN ',I2,'AND',I2,'  IS =',F12.8)
  570  CONTINUE
       IF(MN-NCYCL)480,620,620
  620  WRITE(4,630)NM,RMINI
  630  FORMAT(/,5(10X),24H------------------------,/,5(10X),23H---------
     *--------------,1H-,/,5(10X),2H**,I2,'R MINIMUM=',F8.6,2H**,/,
     *5(10X),24H------------------------,/,5(10X),24H-------------------
     *-----,/)
       WRITE(4,486)
  486  FORMAT(1X,'------------------------------------------------------
     *--------------------------------')
       WRITE(4,640)
  640  FORMAT(1X,'  H  K  L','    FOBS',6X,' SIGFO',4X,'FCALC',6X,'DELF   
     * SF1     SF2    SINT      Y    TDS' )
       WRITE(4,479)
  479  FORMAT(1X,'------------------------------------------------------
     *--------------------------------')
       RM=RMINI*100.
       DO 650 I=1,N
       SITE=SINT(I)*ALMDA**2
       THE=ATAN(SQRT(SITE/(1.-SITE)))*57.295779
       TDS=SIN(THE*2./57.295779)*SITE*CTDS
       CALL EXTIN(RADIS,CELL,THEM,THE,ALMDA,GAMA)
       FCX=SF2(I)
       FCY=SF1(I)
       CALL SFC(ICUBE,JPARA,SM,BGIM,BAM,BCM,FC,IHKL,SINT,I
     *,FCX, FCY,FDX,FDY,AA,GAMA,TDS,Y,D)
       FOBS(I)=FOBS(I)/(SQRT(Y)*SM)
       SIG(I)=SIG(I)/(SQRT(Y)*SM)
       FC(I)=FC(I)/(SQRT(Y)*SM)
       Y=Y-TDS
       P=FOBS(I)-ABS(FC(I))
       PER=P/FOBS(I)*100.
       J=IHKL(I)/1000-12
       K=(IHKL(I)-(J+12)*1000)/40-12
       L=IHKL(I)-(J+12)*1000-(K+12)*40-12
       WRITE  (4,660) J,K,L,FOBS(I),SIG(I),FC(I),P,SF1(I),SF2(I),
     * SINT(I),Y,TDS
       WRITE  (8,661) J,K,L,FOBS(I),FC(I),SIG(I)
  660  FORMAT (1X,3I3,3F10.3,2X,F6.1,3F8.4,1X,F7.5,1X,F6.5)
  661  FORMAT (1X,3I3,3F10.3)
  650  CONTINUE
       WRITE(4,479)
  480  CONTINUE
       IF(IWILS) 370,430,370
  370  P=0.0
       Q=0.0
       R=0.0
       S=0.0
       WRITE (4,380) TITLE
  380  FORMAT (////,10X,'--------------------------------',/,10X,'WILSON
     * PLOT FOR',20A4,/,10X,'--------------------------------',//)
       WRITE(4,478)
  478  FORMAT(1X,'  -------    ----        -----        ----       ---
     *         ----       ---------')
       WRITE(4,474)
  474  FORMAT(1X,'  H  K  L    FOBS        FCALC        DELF       ERR
     *         SINT       LN(FO/FC)')
       WRITE(4,476)
  476  FORMAT(1X,'  -------    ----        -----        ----       ---
     *         ----       ---------')
       SCALE=1.0
       GIM=BGIM
       BAN=BAM
       BCAT=BCM
       DO 390 I=1,N
       SITE=SINT(I)*ALMDA**2
       THE=ATAN(SQRT(SITE/(1.-SITE)))*57.295779
       TDS=SIN(THE*2./57.295779)*SITE*CTDS
       CALL  EXTIN(RADIS,CELL,THEM,THE,ALMDA,GAMA)
       FCX=SF2(I)
       FCY=SF1(I)
       CALL SFC(ICUBE,JPARA,SCALE,GIM,BAN,BCAT,FC,IHKL,SINT,
     *I,FCX,FCY,FDX,FDY,AA,GAMA,TDS,Y,D)
       FOBS(I)=FOBS(I)*SQRT(Y)*SM
       SIG(I)=SIG(I)*SQRT(Y)*SM
       FOC=FC(I)
       U=ALOG(FOBS(I)/FOC)
       FC(I)=U
       P=P+U*SINT(I)
       Q=Q+SINT(I)
       R=R+U
       S=S+SINT(I)**2
       J=IHKL(I)/1000-12
       K=(IHKL(I)-(J+12)*1000)/40-12
       L=IHKL(I)-(J+12)*1000-(K+12)*40-12
  390  CONTINUE
       COM=Q**2-N*S
       SLOPE=(R*Q-N*P)/COM
       YAXIS=(Q*P-R*S)/COM
       P=0.0
       DO 410 I=1,N
       R=FC(I)-(SLOPE*SINT(I)+YAXIS)
  410  P=P+R**2
       ERR=0.6745*SQRT(P/(N-2))
       DIS=N*S-Q**2
       SLERR=ERR*SQRT(N/DIS)
       YAERR=ERR*SQRT(S/DIS)
       WRITE (4,420) SLOPE,SLERR,YAXIS,YAERR
  420  FORMAT (5X,'THERMAL PARAMETERS FROM WILSON PLOT =',F8.4,'  +OR-
     *',F7.5,/,5X,'Y AXIS INTERCEPT FROM WILSON PLOT   =',F8.4,'  +OR-
     *',F7.5)
  430  NC=NC-1
C       IF (NC)670,670,20
        close(2)
	 close(4)
	close(8)
	stop
       END
C     __________________________________________________________________
C
      SUBROUTINE SFC(IC,JP,SC,GIM,BAN,BCAT,FC,IHKL,SINT,I,FC
     *X,FCY,FDX,FDY,AA,GAMA,TDS,Y,D)
C     __________________________________________________________________
C
      DIMENSION  IHKL(1500),SINT(1500),FC(1500),D(16)
       PHI=3.1415292
       J=IHKL(I)/1000-12
       K=(IHKL(I)-(J+12)*1000)/40-12
       L=IHKL(I)-(J+12)*1000-(K+12)*40-12
       TCX=EXP(-BAN*SINT(I))
       TCY=EXP(-BCAT*SINT(I))
       IF(J.EQ.0)GO TO 41
       IS=J/J
       IF (IS*J/2*2-J)31,41,31
31     FOC=4.0*FCY*TCX
       Y=1./SQRT(ABS(1.+GIM*GAMA*FOC**2))
       Y=Y+TDS
       YP=SQRT(Y)/2.*(Y**2+1.)
       D(3)=-4.0*FCY*TCX*SINT(I)*YP
       D(4)=0.0
       GO TO 10
 41    II=ABS(J)+ABS(K)+ABS(L)
       IF(II.EQ.0)GO TO 48
       IS=II/II
       GO TO 49
48     IS=1
49     IF (IS*II/4*4-II)60,50,60
50     FOC=4.0*FCY*TCX+8.0*FCX*TCY
       Y=1./SQRT(ABS(1.+GIM*GAMA*FOC**2))
       Y=Y+TDS
       YP=SQRT(Y)/2.*(Y**2+1.)
       D(3)=-4.0*FCY*TCX*SINT(I)*YP
       D(4)=-8.0*FCX*TCY*YP*SINT(I)
       GO TO 10
60     FOC=4.0*FCY*TCX-8.0*FCX*TCY
       Y=1./SQRT(ABS(1.+GIM*GAMA*FOC**2))
       Y=Y+TDS
       YP=SQRT(Y)/2.*(Y**2+1.)
       D(3)=-4.0*FCY*TCX*SINT(I)*YP
       D(4)=8.0*FCX*TCY*YP*SINT(I)
   10  CONTINUE
       FC(I)=FOC*SC*SQRT(Y)
       D(1)=FC(I)/SC
       D(2)=SC*FOC**3*Y**2.5*GAMA/(-4.)
       D(3)=D(3)*SC
       D(4)=D(4)*SC
       RETURN
       END
C      ________________________________________________
C
       SUBROUTINE EXTIN(RADIS,CELL,THEM,THE,ALMDA,GAMA)
C      ________________________________________________
C
       T=1.5*RADIS
       CONS=ALMDA**3/CELL**6/12.593
       T1=2.*THEM/57.295779
       T2=2.*THE/57.295779
       PX=(1.+(COS(T1))**2*(COS(T2))**2)/(1.+(COS(T1))**2)
       P12=(1.+PX**2)/(1.+PX)
       GAMA=2.*P12*CONS*T/SIN(T2)
       RETURN
       END
C      _____________________________
C
       SUBROUTINE MATRX(A,B,M,FINAL)
C      _____________________________
C
       DIMENSION A(16,16),B(16,16),FINAL(16,16)
       DO 10 I=1,M
       X=A(I,I)
       A(I,I)=1.0
       DO 20 J=1,M
   20  A(I,J)=A(I,J)/X
       DO 10 K=1,M
       IF(K-I)30,10,30
   30  X=A(K,I)
       A(K,I)=0.0
       DO 40 J=1,M
   40  A(K,J)=A(K,J)-X*A(I,J)
   10  CONTINUE
       DO 120 I=1,M
       DO 120 J=1,1
       FINAL(I,J)=0.0
       DO 120 KK=1,M
  120  FINAL(I,J)=FINAL(I,J)+A(I,KK)*B(KK,J)
       RETURN
       END